
import sys
import re

ops = ['/', '*', '+', '-']

last_digit = re.compile(r'(\d+)"*$')
first_digit = re.compile(r'^"*(\d+)')
parenthesis = re.compile(r'\([^(]*\)')

def main( argv ):
    expr = argv[0]

    # replace variable names with the their values
    for arg in sys.argv[2:]:
        variable = arg.split(":");
        expr = expr.replace( variable[0], variable[1] )

    # evaluate all perenthesis
    eval = evaluateParenthesis( expr )
    
    # evaluate all math operations in typical math order
    eval = evaluateAll( eval )
        
    print 'result: ' + eval

def evaluateParenthesis( eval ):
    
    # find all (...) units
    foo = parenthesis.findall( eval )
    
    if foo is None or len(foo) == 0:
        return eval

    # evaluate each parenthesis set
    for str in foo:
        paren = str[1:str.find(")")]
        evaluated = evaluateAll( paren )
        eval = eval.replace( str[0:str.find(")")+1], evaluated )
    
    # recursively evaluate all parenthesis in this SOB
    eval = evaluateParenthesis( eval )

    return eval
    
    
def evaluateAll( eval ):
    for op in ops:
        eval = evaluate( eval, op )

    return eval
    
def evaluate( eval, op ):

    arr = eval.split( op )
    
    while len(arr) > 1:
        try:
            post = first_digit.findall(arr[1])[0]
            pre = last_digit.findall(arr[0])[0]
        except:
            return eval
            
        total = 0
        
        if op == "/":
            total = int(pre) / int(post)

        if op == "*":
            total = int(pre) * int(post)
            
        if op == "+":
            total = int(pre) + int(post)
            
        if op == "-":
            total = int(pre) - int(post)
        
        eval = eval.replace( pre+op+post, str(total) )
        
        arr = eval.split( op )
        
    return eval
        
if __name__ == "__main__":
    main(sys.argv[1:])